require 'proby'
require 'sidekiq'
require 'sidekiq_proby/trackable'

module SidekiqProby
  class Middleware
    def call(worker, msg, queue, &block)
      if worker.kind_of?(SidekiqProby::Trackable)
        Proby.monitor(worker.class.proby_task_id, &block)
      else
        yield
      end
    end
  end
end

Sidekiq.configure_server do |config|
  config.server_middleware do |chain|
    chain.add SidekiqProby::Middleware
  end
end
