module SidekiqProby
  # Public: Mixin for Sidekiq::Worker classes.
  #
  # Examples
  #
  #   class MyWorker
  #     include Sidekiq::Worker
  #     extend SidekiqProby::Trackable
  #
  #     proby_task_id 'aasdoibeo125bk3bu3ljoi'
  #   end
  module Trackable
    module ClassMethods
      # Public: Gets or sets the proby task id.
      #
      # I decided to go with this kinda weird getter/setter behavier to make the
      # familiar syntax for setting the task id possible.
      def proby_task_id(new_id = nil)
        @proby_task_id = new_id if new_id
        @proby_task_id
      end
    end

    def self.included(base) # :nodoc:
      super
      base.extend(SidekiqProby::Trackable::ClassMethods)
    end
  end
end
